#if !defined(__CLONE_KILL__H)
#define __CLONE_KILL__H

//
// by norbert heller  (c) 1998
//
//
//
#include <os2.h>

// the string library
#include "strings.h"

#define  FIRST_TIME     0x0001
#define  RECURSE        0x0002
#define  DO_DIRS        0x0004
#define  DO_FILES       0x0008
#define  NAME_ONLY      0x0010
#define  EDITABLE_TIME  0x0020
#define  IGNORE         2              // Ignore attributes entirely
#define  AllAtts        FILE_NORMAL | FILE_READONLY | FILE_HIDDEN | FILE_SYSTEM | FILE_DIRECTORY | FILE_ARCHIVED

#define  NO_UTIL_ERROR    "0"          /* No error whatsoever        */
#define  ERROR_NOMEM      "2"          /* Insufficient memory        */
#define  ERROR_FILEOPEN   "3"          /* Error opening text file    */
#define  ERROR_RETSTR   "ERROR:"
#define  INVALID_ROUTINE 40            /* Raise Rexx error           */
#define  VALID_ROUTINE    0            /* Successful completion      */


//
// definitions for the settings file
//
typedef struct
{
   // which directories to scan ?? c:\pics;d:\myscanned_pics;...
   CHAR     szDirectories[1000];

    // which files to scan ?? *.gif;*.jpg;*.bmp;...
   CHAR     szFiles[1000];

   BOOL     bRecursive;

   // delete files only from this dir
   CHAR     szKillOnlyDir[1000];
   BOOL     bUnattended;


}SETTINGS;
SETTINGS settings;


// global
typedef struct
{
    char szFilename[CCHMAXPATH];
    char szCheck[35];
    // 8fbdd859353da6231a02eab40fd25a91
}
CLONE;
CLONE clone[300000];

// prototypes
int read_settings(void);

VOID GetCurrDir(char *pszBuffer, int nBufferLen);
BOOL ProcessDir(BOOL bRecurseSubdirs, char * pszCommand);

char szTempFile[CCHMAXPATH];
char szFileName[CCHMAXPATH];
char szTrueName[CCHMAXPATH];

char szTempName[CCHMAXPATH];

ULONG rc;

ULONG numclon;
CHAR szBuffer[300];

// some pointers
char * pF;
char * pF1;
char * pF2;

#define DATABASEFILE "clonekill.dat"
FILE *dbfile ;


//
// for the settings file
//
#define DATAFILE        "CLONEKILL.CFG"
#define IGNORELINE      '#'
#define DELIMITER       "="

// scan directories recursively ? (YES/NO)
#define RECURSIVE       "RECURSIVE"

// kill directly (YES / NO)
#define UNATTENDED      "UNATTENDED"

// kill only in these directories ?
#define KILLONLY        "KILLONLY"

#define DIRECTORIES     "DIRECTORIES"
#define FILENAMES       "FILENAMES"

#endif // CLONE_KILL.H
